Index: pjproject/trunk/pjsip-apps/src/py_pjsua/py_pjsua.c
===================================================================
--- pjproject/trunk/pjsip-apps/src/py_pjsua/py_pjsua.c	(revision 1429)
+++ pjproject/trunk/pjsip-apps/src/py_pjsua/py_pjsua.c	(revision 1430)
@@ -2351,486 +1138,25 @@
 
 /*
- * transport_config_Object
- * Transport configuration for creating UDP transports for both SIP
- * and media.
- */
-typedef struct
-{
-    PyObject_HEAD
-    /* Type-specific fields go here. */
-    unsigned port;
-    PyObject * public_addr;
-    PyObject * bound_addr;
-} transport_config_Object;
-
-
-/*
- * transport_config_dealloc
- * deletes a transport config from memory
- */
-static void transport_config_dealloc(transport_config_Object* self)
-{
-    Py_XDECREF(self->public_addr);    
-    Py_XDECREF(self->bound_addr);    
-    self->ob_type->tp_free((PyObject*)self);
-}
-
-
-/*
- * transport_config_new
- * constructor for transport_config object
- */
-static PyObject * transport_config_new(PyTypeObject *type, PyObject *args,
-                                    PyObject *kwds)
-{
-    transport_config_Object *self;
-
-    self = (transport_config_Object *)type->tp_alloc(type, 0);
-    if (self != NULL)
-    {
-        self->public_addr = PyString_FromString("");
-        if (self->public_addr == NULL)
-    	{
-            Py_DECREF(self);
-            return NULL;
-        }
-		self->bound_addr = PyString_FromString("");
-        if (self->bound_addr == NULL)
-    	{
-            Py_DECREF(self);
-            return NULL;
-        }
-    }
-
-    return (PyObject *)self;
-}
-
-
-/*
- * transport_config_members
- */
-static PyMemberDef transport_config_members[] =
-{
-    {
-        "port", T_INT, offsetof(transport_config_Object, port), 0,
-        "UDP port number to bind locally. This setting MUST be specified "
-        "even when default port is desired. If the value is zero, the "
-        "transport will be bound to any available port, and application "
-        "can query the port by querying the transport info."
-    },
-    {
-        "public_addr", T_OBJECT_EX, 
-	offsetof(transport_config_Object, public_addr), 0,
-        "Optional address to advertise as the address of this transport. "
-        "Application can specify any address or hostname for this field, "
-        "for example it can point to one of the interface address in the "
-        "system, or it can point to the public address of a NAT router "
-        "where port mappings have been configured for the application."		
-    },    
-    {
-        "bound_addr", T_OBJECT_EX, 
-        offsetof(transport_config_Object, bound_addr), 0,
-        "Optional address where the socket should be bound to. This option "
-        "SHOULD only be used to selectively bind the socket to particular "
-        "interface (instead of 0.0.0.0), and SHOULD NOT be used to set the "
-        "published address of a transport (the public_addr field should be "
-        "used for that purpose)."		
-    },    
-    {NULL}  /* Sentinel */
-};
-
-
-
-
-/*
- * transport_config_Type
- */
-static PyTypeObject transport_config_Type =
-{
-    PyObject_HEAD_INIT(NULL)
-    0,                              /*ob_size*/
-    "py_pjsua.Transport_Config",      /*tp_name*/
-    sizeof(transport_config_Object),  /*tp_basicsize*/
-    0,                              /*tp_itemsize*/
-    (destructor)transport_config_dealloc,/*tp_dealloc*/
-    0,                              /*tp_print*/
-    0,                              /*tp_getattr*/
-    0,                              /*tp_setattr*/
-    0,                              /*tp_compare*/
-    0,                              /*tp_repr*/
-    0,                              /*tp_as_number*/
-    0,                              /*tp_as_sequence*/
-    0,                              /*tp_as_mapping*/
-    0,                              /*tp_hash */
-    0,                              /*tp_call*/
-    0,                              /*tp_str*/
-    0,                              /*tp_getattro*/
-    0,                              /*tp_setattro*/
-    0,                              /*tp_as_buffer*/
-    Py_TPFLAGS_DEFAULT,             /*tp_flags*/
-    "Transport Config objects",       /* tp_doc */
-    0,                              /* tp_traverse */
-    0,                              /* tp_clear */
-    0,                              /* tp_richcompare */
-    0,                              /* tp_weaklistoffset */
-    0,                              /* tp_iter */
-    0,                              /* tp_iternext */
-    0,                              /* tp_methods */
-    transport_config_members,         /* tp_members */
-    0,                              /* tp_getset */
-    0,                              /* tp_base */
-    0,                              /* tp_dict */
-    0,                              /* tp_descr_get */
-    0,                              /* tp_descr_set */
-    0,                              /* tp_dictoffset */
-    0,                              /* tp_init */
-    0,                              /* tp_alloc */
-    transport_config_new,             /* tp_new */
-
-};
-
-/*
- * host_port_Object
- * C/Python wrapper for host_port object
- */
-typedef struct
-{
-    PyObject_HEAD
-    /* Type-specific fields go here. */
-    PyObject * host;
-    int port;
-} host_port_Object;
-
-/*
- * host_port_dealloc
- * deletes a host_port from memory
- */
-static void host_port_dealloc(host_port_Object* self)
-{
-    Py_XDECREF(self->host);    
-    self->ob_type->tp_free((PyObject*)self);
-}
-
-
-/*
- * host_port_new
- * constructor for host_port object
- */
-static PyObject * host_port_new(PyTypeObject *type, PyObject *args,
-                                    PyObject *kwds)
-{
-    host_port_Object *self;
-
-    self = (host_port_Object *)type->tp_alloc(type, 0);
-    if (self != NULL)
-    {
-        self->host = PyString_FromString("");
-        if (self->host == NULL)
-    	{
-            Py_DECREF(self);
-            return NULL;
-        }
-        
-    }
-
-    return (PyObject *)self;
-}
-
-
-/*
- * host_port_members
- * declares attributes accessible from both C and Python for host_port object
- */
-static PyMemberDef host_port_members[] =
-{    
-    {
-        "port", T_INT,
-        offsetof(host_port_Object, port), 0,
-        "Port number."
-    },
-    {
-        "host", T_OBJECT_EX,
-        offsetof(host_port_Object, host), 0,
-        "Host part or IP address."
-    },
-    {NULL}  /* Sentinel */
-};
-
-
-/*
- * host_port_Type
- */
-static PyTypeObject host_port_Type =
-{
-    PyObject_HEAD_INIT(NULL)
-    0,                              /*ob_size*/
-    "py_pjsua.Host_Port",        /*tp_name*/
-    sizeof(host_port_Object),    /*tp_basicsize*/
-    0,                              /*tp_itemsize*/
-    (destructor)host_port_dealloc,/*tp_dealloc*/
-    0,                              /*tp_print*/
-    0,                              /*tp_getattr*/
-    0,                              /*tp_setattr*/
-    0,                              /*tp_compare*/
-    0,                              /*tp_repr*/
-    0,                              /*tp_as_number*/
-    0,                              /*tp_as_sequence*/
-    0,                              /*tp_as_mapping*/
-    0,                              /*tp_hash */
-    0,                              /*tp_call*/
-    0,                              /*tp_str*/
-    0,                              /*tp_getattro*/
-    0,                              /*tp_setattro*/
-    0,                              /*tp_as_buffer*/
-    Py_TPFLAGS_DEFAULT,             /*tp_flags*/
-    "Host_port objects",         /*tp_doc*/
-    0,                              /*tp_traverse*/
-    0,                              /*tp_clear*/
-    0,                              /*tp_richcompare*/
-    0,                              /* tp_weaklistoffset */
-    0,                              /* tp_iter */
-    0,                              /* tp_iternext */
-    0,                              /* tp_methods */
-    host_port_members,           /* tp_members */
-	0,                              /* tp_getset */
-    0,                              /* tp_base */
-    0,                              /* tp_dict */
-    0,                              /* tp_descr_get */
-    0,                              /* tp_descr_set */
-    0,                              /* tp_dictoffset */
-    0,                              /* tp_init */
-    0,                              /* tp_alloc */
-    host_port_new,             /* tp_new */
-};
-
-
-
-
-/*
- * transport_info_Object
- * Transport info
- */
-typedef struct
-{
-    PyObject_HEAD
-    /* Type-specific fields go here. */
-    int id;
-    int type;
-    PyObject * type_name;
-    PyObject * info;
-    unsigned flag;
-    unsigned addr_len;
-    host_port_Object * local_name;
-    unsigned usage_count;
-} transport_info_Object;
-
-
-/*
- * transport_info_dealloc
- * deletes a transport info from memory
- */
-static void transport_info_dealloc(transport_info_Object* self)
-{
-    Py_XDECREF(self->type_name); 
-    Py_XDECREF(self->info);
-    Py_XDECREF(self->local_name);
-    self->ob_type->tp_free((PyObject*)self);
-}
-
-
-/*
- * transport_info_new
- * constructor for transport_info object
- */
-static PyObject * transport_info_new(PyTypeObject *type, PyObject *args,
-                                    PyObject *kwds)
-{
-    transport_info_Object *self;
-
-    self = (transport_info_Object *)type->tp_alloc(type, 0);
-    if (self != NULL)
-    {
-        self->type_name = PyString_FromString("");
-        if (self->type_name == NULL)
-    	{
-            Py_DECREF(self);
-            return NULL;
-        }
-        self->info = PyString_FromString("");
-        if (self->info == NULL)
-    	{
-            Py_DECREF(self);
-            return NULL;
-        }
-        self->local_name = 
-            (host_port_Object *)host_port_new(&host_port_Type,NULL,NULL);
-        if (self->local_name == NULL)
-    	{
-            Py_DECREF(self);
-            return NULL;
-        }
-    }
-
-    return (PyObject *)self;
-}
-
-
-/*
- * transport_info_members
- */
-static PyMemberDef transport_info_members[] =
-{
-    {
-        "id", T_INT, offsetof(transport_info_Object, id), 0,
-        "PJSUA transport identification."
-    },
-    {
-        "type", T_INT, offsetof(transport_info_Object, id), 0,
-        "Transport type."
-    },
-    {
-        "type_name", T_OBJECT_EX,
-        offsetof(transport_info_Object, type_name), 0,
-        "Transport type name."
-    },
-    {
-        "info", T_OBJECT_EX,
-        offsetof(transport_info_Object, info), 0,
-        "Transport string info/description."
-    },
-    {
-        "flag", T_INT, offsetof(transport_info_Object, flag), 0,
-        "Transport flag (see ##pjsip_transport_flags_e)."
-    },
-    {
-        "addr_len", T_INT, offsetof(transport_info_Object, addr_len), 0,
-        "Local address length."
-    },
-    {
-        "local_name", T_OBJECT_EX,
-        offsetof(transport_info_Object, local_name), 0,
-        "Published address (or transport address name)."
-    },
-    {
-        "usage_count", T_INT, offsetof(transport_info_Object, usage_count), 0,
-        "Current number of objects currently referencing this transport."
-    },    
-    {NULL}  /* Sentinel */
-};
-
-
-
-
-/*
- * transport_info_Type
- */
-static PyTypeObject transport_info_Type =
-{
-    PyObject_HEAD_INIT(NULL)
-    0,                              /*ob_size*/
-    "py_pjsua.Transport_Info",      /*tp_name*/
-    sizeof(transport_info_Object),  /*tp_basicsize*/
-    0,                              /*tp_itemsize*/
-    (destructor)transport_info_dealloc,/*tp_dealloc*/
-    0,                              /*tp_print*/
-    0,                              /*tp_getattr*/
-    0,                              /*tp_setattr*/
-    0,                              /*tp_compare*/
-    0,                              /*tp_repr*/
-    0,                              /*tp_as_number*/
-    0,                              /*tp_as_sequence*/
-    0,                              /*tp_as_mapping*/
-    0,                              /*tp_hash */
-    0,                              /*tp_call*/
-    0,                              /*tp_str*/
-    0,                              /*tp_getattro*/
-    0,                              /*tp_setattro*/
-    0,                              /*tp_as_buffer*/
-    Py_TPFLAGS_DEFAULT,             /*tp_flags*/
-    "Transport Info objects",       /* tp_doc */
-    0,                              /* tp_traverse */
-    0,                              /* tp_clear */
-    0,                              /* tp_richcompare */
-    0,                              /* tp_weaklistoffset */
-    0,                              /* tp_iter */
-    0,                              /* tp_iternext */
-    0,                              /* tp_methods */
-    transport_info_members,         /* tp_members */
-    0,                              /* tp_getset */
-    0,                              /* tp_base */
-    0,                              /* tp_dict */
-    0,                              /* tp_descr_get */
-    0,                              /* tp_descr_set */
-    0,                              /* tp_dictoffset */
-    0,                              /* tp_init */
-    0,                              /* tp_alloc */
-    transport_info_new,             /* tp_new */
-
-};
-
-/*
- * pjsip_transport_Object
- * C/python typewrapper for pjsip_transport
- */
-typedef struct
-{
-    PyObject_HEAD
-    /* Type-specific fields go here. */
-    pjsip_transport *tp;
-} pjsip_transport_Object;
-
-
-/*
- * pjsip_transport_Type
- */
-static PyTypeObject pjsip_transport_Type =
-{
-    PyObject_HEAD_INIT(NULL)
-    0,                              /*ob_size*/
-    "py_pjsua.PJSIP_Transport",       /*tp_name*/
-    sizeof(pjsip_transport_Object),   /*tp_basicsize*/
-    0,                              /*tp_itemsize*/
-    0,                              /*tp_dealloc*/
-    0,                              /*tp_print*/
-    0,                              /*tp_getattr*/
-    0,                              /*tp_setattr*/
-    0,                              /*tp_compare*/
-    0,                              /*tp_repr*/
-    0,                              /*tp_as_number*/
-    0,                              /*tp_as_sequence*/
-    0,                              /*tp_as_mapping*/
-    0,                              /*tp_hash */
-    0,                              /*tp_call*/
-    0,                              /*tp_str*/
-    0,                              /*tp_getattro*/
-    0,                              /*tp_setattro*/
-    0,                              /*tp_as_buffer*/
-    Py_TPFLAGS_DEFAULT,             /*tp_flags*/
-    "pjsip_transport objects",        /*tp_doc*/
-};
-
-
-/*
  * py_pjsua_transport_config_default
  * !modified @ 051206
  */
-static PyObject *py_pjsua_transport_config_default
-(PyObject *pSelf, PyObject *pArgs)
-{
-    transport_config_Object *obj;
+static PyObject *py_pjsua_transport_config_default(PyObject *pSelf, 
+						   PyObject *pArgs)
+{
+    PyObj_pjsua_transport_config *obj;
     pjsua_transport_config cfg;
 
-    if (!PyArg_ParseTuple(pArgs, ""))
-    {
-        return NULL;
-    }
+    PJ_UNUSED_ARG(pSelf);
+
+    if (!PyArg_ParseTuple(pArgs, "")) {
+        return NULL;
+    }
+
     pjsua_transport_config_default(&cfg);
-    obj = (transport_config_Object *)transport_config_new
-		(&transport_config_Type,NULL,NULL);
-    obj->public_addr = 
-        PyString_FromStringAndSize(cfg.public_addr.ptr, cfg.public_addr.slen);
-    obj->bound_addr = 
-        PyString_FromStringAndSize(cfg.bound_addr.ptr, cfg.bound_addr.slen);
-    obj->port = cfg.port;
+    obj = (PyObj_pjsua_transport_config*)
+	  PyObj_pjsua_transport_config_new(&PyTyp_pjsua_transport_config,
+					   NULL, NULL);
+    PyObj_pjsua_transport_config_import(obj, &cfg);
+
     return (PyObject *)obj;
 }
@@ -2844,21 +1170,18 @@
     pj_status_t status;
     int type;
-    
     PyObject * tmpObj;
-    transport_config_Object *obj;
     pjsua_transport_config cfg;
     pjsua_transport_id id;
-    if (!PyArg_ParseTuple(pArgs, "iO", &type, &tmpObj))
-    {
-        return NULL;
-    }
-    if (tmpObj != Py_None)
-    {
-        obj = (transport_config_Object *)tmpObj;
-        cfg.public_addr.ptr = PyString_AsString(obj->public_addr);
-        cfg.public_addr.slen = strlen(PyString_AsString(obj->public_addr));
-        cfg.bound_addr.ptr = PyString_AsString(obj->bound_addr);
-        cfg.bound_addr.slen = strlen(PyString_AsString(obj->bound_addr));
-        cfg.port = obj->port;
+
+    PJ_UNUSED_ARG(pSelf);
+
+    if (!PyArg_ParseTuple(pArgs, "iO", &type, &tmpObj)) {
+        return NULL;
+    }
+
+    if (tmpObj != Py_None) {
+	PyObj_pjsua_transport_config *obj;
+        obj = (PyObj_pjsua_transport_config*)tmpObj;
+	PyObj_pjsua_transport_config_export(&cfg, obj);
         status = pjsua_transport_create(type, &cfg, &id);
     } else {
@@ -2867,30 +1190,5 @@
     
     
-    return Py_BuildValue("ii",status,id);
-}
-
-/*
- * py_pjsua_transport_register
- * !modified @ 051206
- */
-static PyObject *py_pjsua_transport_register(PyObject *pSelf, PyObject *pArgs)
-{
-    pj_status_t status;	    
-    PyObject * tmpObj;
-    pjsip_transport_Object *obj;	
-    pjsua_transport_id id;
-    if (!PyArg_ParseTuple(pArgs, "O", &tmpObj))
-    {
-        return NULL;
-    }
-    if (tmpObj != Py_None)
-    {
-        obj = (pjsip_transport_Object *)tmpObj;
-        status = pjsua_transport_register(obj->tp, &id);
-    } else {
-        status = pjsua_transport_register(NULL, &id);
-    }
-    
-    return Py_BuildValue("ii",status, id);
+    return Py_BuildValue("ii", status, id);
 }
 
@@ -2906,4 +1204,7 @@
     pjsua_transport_id id[PJSIP_MAX_TRANSPORTS];
     unsigned c, i;
+
+    PJ_UNUSED_ARG(pSelf);
+
     if (!PyArg_ParseTuple(pArgs, ""))
     {
@@ -2935,10 +1236,9 @@
     pj_status_t status;
     int id;
-    transport_info_Object *obj;
     pjsua_transport_info info;
     
-
-    if (!PyArg_ParseTuple(pArgs, "i", &id))
-    {
+    PJ_UNUSED_ARG(pSelf);
+
+    if (!PyArg_ParseTuple(pArgs, "i", &id)) {
         return NULL;
     }	
@@ -2946,10 +1246,9 @@
     status = pjsua_transport_get_info(id, &info);	
     if (status == PJ_SUCCESS) {
-        obj = (transport_info_Object *) transport_info_new
-			(&transport_info_Type,NULL,NULL);
-        obj->addr_len = info.addr_len;
-        obj->flag = info.flag;
-        obj->id = info.id;
-        obj->info = PyString_FromStringAndSize(info.info.ptr, info.info.slen);
+	PyObj_pjsua_transport_info *obj;
+        obj = (PyObj_pjsua_transport_info *) 
+	      PyObj_pjsua_transport_info_new(&PyTyp_pjsua_transport_info, 
+					     NULL, NULL);
+	PyObj_pjsua_transport_info_import(obj, &info);
         return Py_BuildValue("O", obj);
     } else {
@@ -2968,4 +1267,7 @@
     int id;
     int enabled;
+
+    PJ_UNUSED_ARG(pSelf);
+
     if (!PyArg_ParseTuple(pArgs, "ii", &id, &enabled))
     {
@@ -2985,4 +1287,7 @@
     int id;
     int force;
+
+    PJ_UNUSED_ARG(pSelf);
+
     if (!PyArg_ParseTuple(pArgs, "ii", &id, &force))
     {
@@ -3001,8 +1306,4 @@
     "py_pjsua.Transport_Config cfg) "
     "Create SIP transport.";
-static char pjsua_transport_register_doc[] =
-    "int, int py_pjsua.transport_register "
-    "(py_pjsua.PJSIP_Transport tp) "
-    "Register transport that has been created by application.";
 static char pjsua_enum_transports_doc[] =
     "int[] py_pjsua.enum_transports () "
